/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.antrax.storage.enums.CellStatus;
import com.flamesgroup.commons.ChannelUID;
import com.flamesgroup.storage.convert.CellStatusConverter;
import com.flamesgroup.storage.convert.ChannelUIDConverter;
import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.NetworkSurveyRecord;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class NetworkSurvey extends TableImpl<NetworkSurveyRecord> {

	private static final long serialVersionUID = 586928980;

	/**
	 * The reference instance of <code>public.network_survey</code>
	 */
	public static final NetworkSurvey NETWORK_SURVEY = new NetworkSurvey();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<NetworkSurveyRecord> getRecordType() {
		return NetworkSurveyRecord.class;
	}

	/**
	 * The column <code>public.network_survey.id</code>.
	 */
	public final TableField<NetworkSurveyRecord, Integer> ID = createField("id", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.network_survey.arfcn</code>.
	 */
	public final TableField<NetworkSurveyRecord, Integer> ARFCN = createField("arfcn", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.network_survey.bsic</code>.
	 */
	public final TableField<NetworkSurveyRecord, Integer> BSIC = createField("bsic", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.network_survey.rxlev</code>.
	 */
	public final TableField<NetworkSurveyRecord, Integer> RXLEV = createField("rxlev", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.network_survey.ber</code>.
	 */
	public final TableField<NetworkSurveyRecord, Float> BER = createField("ber", org.jooq.impl.SQLDataType.REAL, this, "");

	/**
	 * The column <code>public.network_survey.mcc</code>.
	 */
	public final TableField<NetworkSurveyRecord, Short> MCC = createField("mcc", org.jooq.impl.SQLDataType.SMALLINT, this, "");

	/**
	 * The column <code>public.network_survey.mnc</code>.
	 */
	public final TableField<NetworkSurveyRecord, Short> MNC = createField("mnc", org.jooq.impl.SQLDataType.SMALLINT, this, "");

	/**
	 * The column <code>public.network_survey.lac</code>.
	 */
	public final TableField<NetworkSurveyRecord, Integer> LAC = createField("lac", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.network_survey.cell_id</code>.
	 */
	public final TableField<NetworkSurveyRecord, Integer> CELL_ID = createField("cell_id", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.network_survey.cell_status</code>.
	 */
	public final TableField<NetworkSurveyRecord, CellStatus> CELL_STATUS = createField("cell_status", org.jooq.impl.SQLDataType.CLOB, this, "", new CellStatusConverter());

	/**
	 * The column <code>public.network_survey.arfcns</code>.
	 */
	public final TableField<NetworkSurveyRecord, Integer[]> ARFCNS = createField("arfcns", org.jooq.impl.SQLDataType.INTEGER.getArrayDataType(), this, "");

	/**
	 * The column <code>public.network_survey.neighbours_arfcn</code>.
	 */
	public final TableField<NetworkSurveyRecord, Integer[]> NEIGHBOURS_ARFCN = createField("neighbours_arfcn", org.jooq.impl.SQLDataType.INTEGER.getArrayDataType(), this, "");

	/**
	 * The column <code>public.network_survey.add_time</code>.
	 */
	public final TableField<NetworkSurveyRecord, Date> ADD_TIME = createField("add_time", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false), this, "", new DateConverter());

	/**
	 * The column <code>public.network_survey.gsm_channel</code>.
	 */
	public final TableField<NetworkSurveyRecord, ChannelUID> GSM_CHANNEL = createField("gsm_channel", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new ChannelUIDConverter());

	/**
	 * The column <code>public.network_survey.server_id</code>.
	 */
	public final TableField<NetworkSurveyRecord, Long> SERVER_ID = createField("server_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "");

	/**
	 * Create a <code>public.network_survey</code> table reference
	 */
	public NetworkSurvey() {
		this("network_survey", null);
	}

	/**
	 * Create an aliased <code>public.network_survey</code> table reference
	 */
	public NetworkSurvey(String alias) {
		this(alias, NETWORK_SURVEY);
	}

	private NetworkSurvey(String alias, Table<NetworkSurveyRecord> aliased) {
		this(alias, aliased, null);
	}

	private NetworkSurvey(String alias, Table<NetworkSurveyRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<NetworkSurveyRecord, Integer> getIdentity() {
		return Keys.IDENTITY_NETWORK_SURVEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<NetworkSurveyRecord> getPrimaryKey() {
		return Keys.NETWORK_SURVEY_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<NetworkSurveyRecord>> getKeys() {
		return Arrays.<UniqueKey<NetworkSurveyRecord>>asList(Keys.NETWORK_SURVEY_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public NetworkSurvey as(String alias) {
		return new NetworkSurvey(alias, this);
	}

	/**
	 * Rename this table
	 */
	public NetworkSurvey rename(String name) {
		return new NetworkSurvey(name, null);
	}
}
